<p align="center">
<a href="https://www.kitura.dev">
<img src="https://raw.githubusercontent.com/Kitura/Kitura/master/Documentation/KituraLogo-wide.png" height="100" alt="Kitura">
</a>
<p align="center"><strong>A Swift Web Framework and HTTP Server</strong></p>
</p>

<p align="center">
<a href="https://www.kitura.io/packages.html#all">
<img src="https://img.shields.io/badge/docs-kitura.io-1FBCE4.svg" alt="Docs">
</a>
<a href="https://travis-ci.org/Kitura/Kitura">
<img src="https://travis-ci.org/Kitura/Kitura.svg?branch=master" alt="Build Status - Master">
</a>
<img src="https://img.shields.io/badge/os-macOS-green.svg?style=flat" alt="macOS">
<img src="https://img.shields.io/badge/os-linux-green.svg?style=flat" alt="Linux">
<img src="https://img.shields.io/badge/license-Apache2-blue.svg?style=flat" alt="Apache 2">
<a href="https://codecov.io/gh/Kitura/Kitura">
<img src="https://codecov.io/gh/Kitura/Kitura/branch/master/graph/badge.svg" alt="codecov">
</a>
<a href="https://codebeat.co/projects/github-com-ibm-swift-kitura">
<img src="https://codebeat.co/badges/d2d1cb10-e587-44b7-b63a-0a76ffb7bd96" alt="codebeat badge">
</a>
<a href="http://swift-at-ibm-slack.mybluemix.net/">
<img src="http://swift-at-ibm-slack.mybluemix.net/badge.svg" alt="Slack Status">
</a>
</p>


## Summary

Kitura is a web framework and web server that is created for web services written in Swift. For more information, visit [www.kitura.dev](https://www.kitura.dev).

## Table of Contents
* [Summary](#summary)
* [Features](#features)
* [Getting Started](#getting-started)
* [Contributing to Kitura](#contributing-to-kitura)
* [Community](#community)

## Features

- URL routing (e.g., GET, POST, PUT, DELETE, PATCH)
- Codable routing
- URL parameters
- Static file serving
- [FastCGI support](https://github.com/Kitura/Kitura/blob/master/Documentation/FastCGI.md)
- SSL/TLS support
- Pluggable middleware

## Getting Started

Visit [https://www.kitura.dev](https://www.kitura.dev/) for a Getting Started guide, tutorials, and API reference documentation.

## Contributing to Kitura

All improvements to Kitura are very welcome! Here's how to get started with developing Kitura itself.

1. Clone this repository.

  `$ git clone https://github.com/Kitura/Kitura`

2. Build and run tests.

  `$ swift test`

You can find more info on contributing to Kitura in our [contributing guidelines](https://github.com/Kitura/Kitura/blob/master/.github/CONTRIBUTING.md).

## Notes

* Swift-NIO is now the default network engine via the Kitura-NIO package.  If for some reason you require the old Kitura-net package, you can still enable it by setting an environment variable `KITURA_NIO=0` during build.
* Most Kitura packages have been updated to require at least Swift 5.2 in order to maintain backward compatibility.


## Community

We love to talk server-side Swift, and Kitura. Join our [Slack](http://swift-at-ibm-slack.mybluemix.net/) to meet the team!
